//
// Code generated by present.rpc.SwiftGenerator: Do not edit.
// Source file: {{SourceFile}}
//
// For use with protocol buffer classes generated by the Swift protocol buffer generator compiler:
//   https://github.com/apple/swift-protobuf/
// For more information see:
//   https://github.com/presentco/present-rpc

import Foundation
import SwiftProtobuf

enum {{ServiceName}}_Error {
    case NetworkError(Error)
    case NoData()
    case UnableToParseResponse(String)
}

enum {{ServiceName}}_Response<T> {
    case Success(T)
    case Failure({{ServiceName}}_Error)
}

struct {{ServiceName}} {
    let serviceUrl: URL

    init(serviceUrl: URL) {
        self.serviceUrl = serviceUrl
    }

    func urlRequest(forServiceMethod path: String, withArg arg: SwiftProtobuf.Message) -> URLRequest {
        let url = self.serviceUrl.appendingPathComponent(path)
        var request = URLRequest(url: url)
        request.httpMethod = "POST"
        request.addValue("application/x-protobuf", forHTTPHeaderField: "Content-Type")
        request.httpBody = try! arg.serializedData()
        return request
    }

    func post<T: SwiftProtobuf.Message>(
        serviceMethod path: String,
        arg: SwiftProtobuf.Message,
        completion: @escaping ({{ServiceName}}_Response<T>)->Void)
    {
        let request = urlRequest(forServiceMethod: path, withArg: arg)
        let task = URLSession.shared.dataTask(with: request)
        { (data, response, error) in
            if let error = error {
                completion({{ServiceName}}_Response.Failure({{ServiceName}}_Error.NetworkError(error)))
                return
            }
            guard let content = data else {
                completion({{ServiceName}}_Response.Failure({{ServiceName}}_Error.NoData()))
                return
            }
            guard let response = try? T(serializedData: content) else {
                let error = {{ServiceName}}_Error.UnableToParseResponse(String(describing: String(data: content, encoding: .utf8)))
                completion({{ServiceName}}_Response.Failure(error))
                return
            }
            completion({{ServiceName}}_Response.Success(response))
        }

       task.resume() // to start the url session
    }
}
